'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var React = require('react');
var deepForceUpdate = require('react-deep-force-update');
var Redbox = require('redbox-react');
var Component = React.Component;

// Feature check for the createElement() patch.
// If createElement() was patched, types with
// the same __source will resolve to the same type.

var wasCreateElementPatched = false;
var A = function A() {};
A.__source = { fileName: 'fake', localName: 'fake' };
var B = function B() {};
B.__source = { fileName: 'fake', localName: 'fake' };
if (React.createElement(A, null).type === React.createElement(B, null).type) {
  wasCreateElementPatched = true;
}

var AppContainer = function (_Component) {
  _inherits(AppContainer, _Component);

  function AppContainer(props) {
    _classCallCheck(this, AppContainer);

    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(AppContainer).call(this, props));

    _this.state = { error: null };
    return _this;
  }

  _createClass(AppContainer, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      if (!wasCreateElementPatched) {
        console.error('React Hot Loader: It appears that "react-hot-loader/patch" ' + 'did not run immediately before the app started. Make sure that it ' + 'runs before any other code. For example, if you use Webpack, ' + 'you can add "react-hot-loader/patch" as the very first item to the ' + '"entry" array in its config. Alternatively, you can add ' + 'require("react-hot-loader/patch") as the very first line ' + 'in the application code, before any other imports.');
      }
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      // Hot reload is happening.
      // Retry rendering!
      if (this.hasChildTypeChanged(nextProps)) {
        this.setState({
          error: null
        });
      }
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate(prevProps) {
      // Hot reload has finished.
      // Force-update the whole tree, including
      // components that refuse to update.
      if (this.hasChildTypeChanged(prevProps)) {
        deepForceUpdate(this);
      }
    }

    // This hook is going to become official in React 15.x.
    // In 15.0, it only catches errors on initial mount.
    // Later it will work for updates as well:
    // https://github.com/facebook/react/pull/6020

  }, {
    key: 'unstable_handleError',
    value: function unstable_handleError(error) {
      this.setState({
        error: error
      });
    }
  }, {
    key: 'hasChildTypeChanged',
    value: function hasChildTypeChanged(props) {
      // Backwards compat
      if (props.component !== this.props.component) {
        return true;
      }

      return props.children && this.props.children && props.children.type !== this.props.children.type;
    }
  }, {
    key: 'render',
    value: function render() {
      var error = this.state.error;

      if (error) {
        return React.createElement(this.props.errorReporter, { error: error });
      }

      if (this.props.component) {
        return React.createElement(this.props.component, this.props.props);
      } else {
        return React.Children.only(this.props.children);
      }
    }
  }]);

  return AppContainer;
}(Component);

AppContainer.propTypes = {
  component: function component(props) {
    if (props.component) {
      return new Error('Passing "component" prop to <AppContainer /> is deprecated. ' + 'Replace <AppContainer component={App} /> with <AppContainer><App /></AppContainer>.');
    }
  },
  props: function props(_props) {
    if (_props.props) {
      return new Error('Passing "props" prop to <AppContainer /> is deprecated. ' + 'Replace <AppContainer component={App} props={{ myProp: myValue }} /> with <AppContainer><App myProp={myValue} /></AppContainer>.');
    }
  },
  children: function children(props) {
    if (React.Children.count(props.children) !== 1) {
      return new Error('Invalid prop "children" supplied to AppContainer. Expected a single React element with your app’s root component, e.g. <App />.');
    }
  }
};

AppContainer.defaultProps = {
  errorReporter: Redbox
};

module.exports = AppContainer;